#ifndef CPU_X86_H_
#define CPU_X86_H_

/////////////////////////////////////////////////////////////////////////
/* for x86 CPU */
// x86 - Spec
#define		MU_tFPU					(1<<0)
#define		MU_tMMX					(1<<1)
#define		MU_t3DN					(1<<2)
#define		MU_tSSE					(1<<3)
#define		MU_tCMOV				(1<<4)
#define		MU_tE3DN				(1<<5)	/* for Athlon(Externd 3D Now!) */
#define 	MU_tEMMX				(1<<6)  /* EMMX = E3DNow!_INT = SSE_INT  */
#define		MU_tSSE2				(1<<7)
#define 	MU_tCLFLUSH				(1<<18)
#define 	MU_tMULTI				(1<<12)	/* for Multi-threaded encoder. Never set on UP or in the binary linked w/o multithread lib. */

// x86 - Vendor
#define 	MU_tINTEL				(1<<8)
#define 	MU_tAMD					(1<<9)
#define 	MU_tCYRIX				(1<<10)
#define 	MU_tIDT					(1<<11)
#define 	MU_tUNKNOWN				(1<<15)	/* unknown vendor */

// x86 - Special
#define 	MU_tSPC1 				(1<<16)	/* special flag */
#define 	MU_tSPC2 				(1<<17)	/* freely available */
// x86 - CPU TYPES
#define 	MU_tFAMILY4				(1<<20)	/* 486 vendor maybe isn't correct */
#define 	MU_tFAMILY5				(1<<21)	/* 586 (P5, P5-MMX, K6, K6-2, K6-III) */
#define 	MU_tFAMILY6				(1<<22)	/* 686 above P-Pro, P-II, P-III, Athlon */
#define 	MU_tFAMILY7				(1<<23) /* Pentium IV ? */


#ifdef INDEPENDENT_DKC_MT
#	include "define.h"
#else
#	include <dkutil_c/dkutil_cstd/define.h>
#endif
DKC_EXTERN int haveX86_UNIT(void);

#endif /* CPU_X86_H_ */
