/**
@author d
@since 2006/01/18
@file dkcMTRand64.h
@brief Mersenne Twister algorithm wrapper on 64bit
@todo
CC֐gȂRpC̏ꍇ͈ȉ̂悤ȋKŏĂ݂ĂB
@code
#define dkcMTRand64_real3_base(func,p) \
	( ((func(p) >> 12) + 0.5) * (1.0/4503599627370496.0) );

#define dkcMTRand64_real3(p) dkcMTRand64_real3_base(dkcMTRand64Get,p)
@endcode
*/

#ifndef DKUTIL_C_MT_RAND64_H
#define DKUTIL_C_MT_RAND64_H


#ifdef INDEPENDENT_DKC_MT
#	include "define.h"
#else
#	include <dkutil_c/dkutil_cstd/define.h>
#endif
#include <stdio.h>

#define dkcdMT_RAND64_NN 312
typedef struct dkc_Mersenne_Twister_64bit{
	/** The array for the state vector */
	uint64 state[dkcdMT_RAND64_NN];
	uint64 output[dkcdMT_RAND64_NN];
	int index;
	char *mallocPtr;
	void *function_ptr;
}DKC_MT_RAND64;

typedef void (*DKC_MT_RAND64_GENERATE_F_TYPE)(	DKC_MT_RAND64 * );


DKC_EXTERN DKC_MT_RAND64 *WINAPI dkcAllocMTRand64(uint64 seed);

DKC_EXTERN int WINAPI dkcFreeMTRand64(DKC_MT_RAND64 **p);


/**
@warning KdkcAllocMTRand64()Ŋmۂ̈ĂB
*/
DKC_EXTERN void WINAPI dkcMTRand64Init(DKC_MT_RAND64 *p,uint64 seed);
/**
@warning KdkcAllocMTRand64()Ŋmۂ̈ĂB
*/
DKC_EXTERN void WINAPI 
	dkcMTRand64InitByArray(DKC_MT_RAND64 *p,uint64 *init_key,uint64 key_length);


DKC_EXTERN uint64 WINAPI dkcMTRand64Get(DKC_MT_RAND64 *p);

DKC_EXTERN void dkcMTRand64Next_C(DKC_MT_RAND64 *p);

/**
@see dkcMTRand32SetNextFunction()̒ӏ warningĂB
*/
///֐B
DKC_INLINE void dkcMTRand64SetNextFunction(DKC_MT_RAND64 *p,DKC_MT_RAND64_GENERATE_F_TYPE f)
{
	p->function_ptr = f;
}

/** generates a random number on [0, 2^64-1]-interval */
DKC_INLINE uint64 dkcMTRand64Get_INL(DKC_MT_RAND64 *p)
{

    uint64 x;
	
    if (p->index >= dkcdMT_RAND64_NN) { /* generate NN words at one time */
			DKC_MT_RAND64_GENERATE_F_TYPE fp;
			fp = p->function_ptr;
			fp(p);
    }
    x = p->output[(p->index)++];
	
    /*
		x ^= (x >> 29) & dkcmUINT64DEFINE(0x5555555555555555);
    x ^= (x << 17) & dkcmUINT64DEFINE(0x71D67FFFEDA60000);
    x ^= (x << 37) & dkcmUINT64DEFINE(0xFFF7EEE000000000);
    x ^= (x >> 43);
		*/
    return x;
}



/** generates a random number on [0, 2^63-1]-interval */
DKC_INLINE int64 dkcMTRand64_Get63(DKC_MT_RAND64 *p)
{
    return (int64)(dkcMTRand64Get(p) >> 1);
}

/** generates a random number on [0,1]-real-interval */
DKC_INLINE double dkcMTRand64_real1(DKC_MT_RAND64 *p)
{
    return (dkcMTRand64Get(p) >> 11) * (1.0/9007199254740991.0);
}

/** generates a random number on [0,1)-real-interval */
DKC_INLINE double dkcMTRand64_real2(DKC_MT_RAND64 *p)
{
    return (dkcMTRand64Get(p) >> 11) * (1.0/9007199254740992.0);
}

/** generates a random number on (0,1)-real-interval */
DKC_INLINE double dkcMTRand64_real3(DKC_MT_RAND64 *p)
{
    return ((dkcMTRand64Get(p) >> 12) + 0.5) * (1.0/4503599627370496.0);
}
#endif



