#define INDEPENDENT_DKC_MT
#include "dkcMTRand.h"
#ifdef dkcdMultiThread
#	ifdef NDEBUG
#		pragma comment(lib,"dkingyoMTDLLMT")
#	else
#		pragma comment(lib,"dkingyoMTDLLMTd")
#	endif
#else
#	ifdef NDEBUG
#		pragma comment(lib,"dkingyoMTDLL")
#	else
#		pragma comment(lib,"dkingyoMTDLLd")
#	endif
#endif
int test_mt64(){
	int i;
	uint64 init[4]={0x12345, 0x23456	, 0x34567, 0x45678}, length=4;
	DKC_MT_RAND64 *pctx = dkcAllocMTRand64(0);
	dkcMTRand64InitByArray(pctx,init, length);
	printf("1000 outputs of dkcMTRand64Get()\n");
	for (i=0; i<1000; i++) {
#ifdef _MSC_VER
		printf("%20I64u", dkcMTRand64Get(pctx));
#else
		printf("%20llu ", dkcMTRand64Get(pctx));
#endif
		if (i%5==4) printf("\n");
	}
	printf("\n1000 outputs of dkcMTRand64_real2()\n");
	for (i=0; i<1000; i++) {
		printf("%10.8f ", dkcMTRand64_real2(pctx));
		if (i%5==4) printf("\n");
	}
	dkcFreeMTRand64(&pctx);
	return 0;
}

int test_mt32(){
  int i;
  unsigned long init[4]={0x123, 0x234, 0x345, 0x456}, length=4;
	DKC_MT_RAND32 *pctx = dkcAllocMTRand32(0);
  dkcMTRand32InitByArray(pctx,init, length);
  printf("1000 outputs of dkcMTRand32Get()\n");
  for (i=0; i<1000; i++) {
    printf("%10lu ", dkcMTRand32Get(pctx));
    if (i%5==4) printf("\n");
  }
  printf("\n1000 outputs of dkcMTRand32Get_real2()\n");
  for (i=0; i<1000; i++) {
    printf("%10.8f ", dkcMTRand32Get_real2(pctx));
    if (i%5==4) printf("\n");
  }
	dkcFreeMTRand32(&pctx);
  return 0;
}

void printline(){
	printf("-------------------------------\n");
}
///Test Code
int main(void)
{
	printline();
	//test_mt32();
	printline();
	test_mt64();
#if defined(_MSC_VER) && defined(_DEBUG)
	system("PAUSE");
#endif
}